//******************************************************************************
// Menu.java   :	Applet
// Coder       :    Jeremy C. Witt
// Date        :    September 1997
// Copyright   :    All Rights Reserverd
// Desc        :    This applet implements a cool looking menu Navigation
//                  tool similar to one I saw at www.btinternet.com/~ry/Codebase
//                  It features a few inhancements and changes
//
//******************************************************************************
import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;


// Main Class for applet Menu
// *****************************************************
public class jwMenu extends Applet implements Runnable
{
	// THREAD SUPPORT:
	// m_Menu is the Thread object for the applet
	Thread	 m_jwMenu = null;

    // Parameter Support
    // Members for applet parameters
    // <type>       <MemberVar>    = <Default Value>
    // ***********************************************************************
	String m_Item           = "Item";       // This is the Default Item +
	int    m_NumItems       = 1;            // Number of Menu Items +
	String m_BGColor        = "DD0000";     // Background Color +
	String m_TFColor        = "F0F0F0";     // Fore Text Color +
	String m_THColor        = "FFFFFF";     // Fore Text Color Highlight +
	String m_TMColor        = "FFFFFF";     // Message Text Color +
	String m_LColor         = "FFFF00";     // Link Color String +
	String m_AColor         = "FF0000";     // Active Link Color String +
	String m_LineColor      = "FFFF00";     // Line Color +
	int    m_Spacing        = 60;           // Spacing between entries
	String m_UseArrow       = "NO";         // Use Arrows Flag
	String m_defaultTarget  = "_top";       // Default Target
	String m_Location       = "TOP";        // Top or Bottom Applet
	int    m_AStyle          = 1;           // Line/NoLine/FlareLine
	String m_font           = "Helvetica";  // Font Type
	String m_Mfont          = "Helvetica";  // Message Font
	String m_style          = "PLAIN";      // Font Style (BG Font is Bold)
	String m_Mstyle         = "PLAIN";      // Message Style
	int    m_size           = 10;           // Font Base Size
	int    m_Msize          = 8;            // Message Size
	int    m_fps            = 15;           // Frms/Sec(Update Speed)
	int    m_FadeSpeed      = 10;           // Speed of Fading Lines
	int    m_LineDist       = 8;            // Distance in Pixls Cent-Line
	int    m_BarWidth       = 25;           // Configurible BarWidths

    // parameter names. to change the name of a parameter,
	// you need only make a single change. simply modify
	// the value of the parameter string below.
    // *************************************************
	final String PARAM_Item         = "item";
	final String PARAM_font         = "font";
	final String PARAM_Mfont        = "msgfont";
	final String PARAM_style        = "style";
	final String PARAM_Mstyle       = "msgstyle";
	final String PARAM_size         = "size";
	final String PARAM_Msize        = "msgsize";
	final String PARAM_fps          = "fps";
	final String PARAM_BGColor      = "bgcolor";
	final String PARAM_TBColor      = "tbcolor";
	final String PARAM_TFColor      = "tfcolor";
	final String PARAM_THColor      = "thcolor";
	final String PARAM_TMColor      = "tmcolor";
	final String PARAM_LColor       = "lcolor";
	final String PARAM_AColor       = "acolor";
	final String PARAM_LineColor    = "linecolor";
	final String PARAM_Style        = "style";
	final String PARAM_NumItems     = "numitems";
	final String PARAM_Spacing      = "spacing";
	final String PARAM_UseArrow     = "usearrow";
	final String PARAM_defaultTarget= "deftarget";
	final String PARAM_Location     = "location";
	final String PARAM_AStyle       = "astyle";
	final String PARAM_FadeSpeed    = "fadespeed";
	final String PARAM_LineDist     = "linedist";
	final String PARAM_BarWidth     = "barwidth";


    // Other member Variables

    private Vector m_URL      = new Vector(10,10); // This holds URLs
    private Vector m_Target   = new Vector(10,10); // This holds Targets
    private Vector m_Message  = new Vector(10,10); // This holds Messages
    private Vector m_TextSize = new Vector(10,10); // this holds Size of Texts
    private Vector m_Text     = new Vector(10,10); // Texts

    private Font TFfont;            // Foreground Font
    private Font TMfont;            // Message Font
    private FontMetrics ff;         // Forground FontMetrics
    private FontMetrics fm;         // Message FontMetrics
    private Color m_CurrFTColor;    // The Color used currently for Forgrnd Text
    private Color m_MsgTColor;      // Color Var for Background Text
    private Color m_ForeTColor;     // Color Var for ForeGround Text
    private Color m_HlteTColor;     // Highlight Color Var for Forg Text
    private Color m_BackgColor;     // Background Color
    private Color m_ClnColor;       // LineColor
    private Color m_LinkTColor;     // LinkColor
    private int   CMouse_X=-30;     // Mouse location X
    private int   CMouse_Y=-30;     // Mouse Location Y
    private float FadePercent=1;    // Curr Fade % for the lines
    private int   FadeDirection=1;  // Fading up or Down...
    private int   TxtXOffset;       // current X offset of the text.
    private int   ItemOvered = -1;  // This is the Item Number Click Handle


	// Set up Double Buffer Stuff
	Graphics DBGrafix;
	Image    DBImage;


	// APPLET INFO SUPPORT:
	// The getAppletInfo() method returns a string describing the applet's
	// author, copyright date, or miscellaneous information.
    // *******************************************************************
	public String getAppletInfo()
	{
		return "Name: JWMenu\r\n" +
		       "Author: Jeremy C. Witt (Reverse Engineered)\r\n" +
		       "Created on 9-10-97\r\n" +
		       "Note: All code was created from scratch";
	}

	// PARAMETER SUPPORT
	// The getParameterInfo() method returns an array of strings describing
	// the parameters understood by this applet.
	//
    // Marquee Parameter Information:
    //  { "Name", "Type", "Description" },
    // **********************************************
	public String[][] getParameterInfo()
	{
		String[][] info =
		{
			{ PARAM_Item, "String", "Not Used" },
		};
		return info;
	}

    // INIT. Most of the Heavy Duty Initialization is contained here
    // **************************************************************
    public void init()
	{
	    int index = 0;
	    String tURL = "url";
	    String tTar = "target";
	    String tMes = "message";
	    String tText= "text";
	    String tTemp= "";
	    String param;


    	//----GET THE PARAMS JW
		// ********************************
		param = getParameter(PARAM_Item);
		if (param != null)
			m_Item = param;
		param = getParameter(PARAM_font);
		if (param != null)
			m_font = param;
		param = getParameter(PARAM_style);
		if (param != null)
			m_style = param;
		param = getParameter(PARAM_size);
		if (param != null)
			m_size = Integer.parseInt(param);
        param = getParameter(PARAM_Mfont);
        if (param != null)
            m_Mfont = param;
        param = getParameter(PARAM_Mstyle);
        if (param != null)
            m_Mstyle = param;
        param = getParameter(PARAM_Msize);
        if (param != null)
            m_Msize = Integer.parseInt(param);
		param = getParameter(PARAM_fps);
		if (param != null)
			m_fps = Integer.parseInt(param);
        param = getParameter(PARAM_BGColor);
        if (param != null)
            m_BGColor = param;
        param = getParameter(PARAM_THColor);
        if (param != null)
            m_THColor = param;
        param = getParameter(PARAM_TMColor);
        if (param != null)
            m_TMColor = param;
        param = getParameter(PARAM_TFColor);
        if (param != null)
            m_TFColor = param;
        param = getParameter(PARAM_LineColor);
        if (param != null)
            m_LineColor = param;
        param = getParameter(PARAM_LColor);
        if (param != null)
            m_LColor = param;
        param = getParameter(PARAM_AColor);
        if (param != null)
            m_AColor = param;
        param = getParameter(PARAM_AStyle);
        if (param != null)
            m_AStyle = Integer.parseInt(param);
        param = getParameter(PARAM_Spacing);
        if (param != null)
            m_Spacing = Integer.parseInt(param);
        param = getParameter(PARAM_UseArrow);
        if (param != null)
            m_UseArrow = param;
        param = getParameter(PARAM_defaultTarget);
        if (param != null)
            m_defaultTarget = param;
        param = getParameter(PARAM_Location);
        if (param != null)
            m_Location = param;
        param = getParameter(PARAM_FadeSpeed);
        if (param != null)
            m_FadeSpeed = Integer.parseInt(param);
        param = getParameter(PARAM_LineDist);
        if (param != null)
            m_LineDist = Integer.parseInt(param);
        param = getParameter(PARAM_BarWidth);
        if (param != null)
            m_BarWidth = Integer.parseInt(param);
        param = getParameter(PARAM_NumItems);
        if (param != null)
        {
            m_NumItems = Integer.parseInt(param);
            System.out.println("NumItems=" + m_NumItems);
            while (index < m_NumItems)
            {
                tTemp = tText + index; // Make text[i] String
                param = getParameter(tTemp);
                if (param != null)
                    m_Text.addElement(param);
                else
                    m_Text.addElement("NoString");
                tTemp = tURL + index; // Make url[i] String
                param = getParameter(tTemp);
                if (param != null)
                    m_URL.addElement(param);
                else
                    m_URL.addElement("http://www.bluesnews.com");

                System.out.println((String)m_URL.elementAt(index));
                // Make Target Vector Additions
                tTemp = tTar + index; // Make target[i] String
                param = getParameter(tTemp);
                if (param != null)
                    m_Target.addElement(param);
                else
                    m_Target.addElement(m_defaultTarget);

                // Make Message Additions
                tTemp = tMes + index; // Make message[i] String
                param = getParameter(tTemp);
                if (param != null)
                    m_Message.addElement(param);
                else
                    m_Message.addElement("");
                index++;
            }
        }


        // Create the Image Buffer(s)
		DBImage = createImage(size().width,size().height);

		// Get the Grafix context of the image and set it to our Double
		// Buffer, and background buffer
		DBGrafix = DBImage.getGraphics();


        // create the fonts here based on the parameters entered
        int nStyle = Font.PLAIN;
        if (m_style.equalsIgnoreCase("BOLD"))
            nStyle = Font.BOLD;
        if (m_style.equalsIgnoreCase("ITALIC"))
            nStyle = Font.ITALIC;

        TFfont = new Font(m_font, nStyle, m_size); // Make Reg Font

        nStyle = Font.PLAIN;
        if (m_Mstyle.equalsIgnoreCase("BOLD"))
            nStyle = Font.BOLD;
        if (m_Mstyle.equalsIgnoreCase("ITALIC"))
            nStyle = Font.ITALIC;

        TMfont = new Font(m_Mfont, nStyle,  m_Msize); // Make Message Font

        // Calculate Font and Font Sizing Params for use later
        // as well as Initialize Scroller Variables
        ff = getFontMetrics(TFfont);
        fm = getFontMetrics(TMfont);

        // Set up the Colors and Stuff
        m_MsgTColor    = ColorParse(m_TMColor);
        m_ForeTColor   = ColorParse(m_TFColor);
        m_HlteTColor   = ColorParse(m_THColor);
        m_BackgColor   = ColorParse(m_BGColor);
        m_ClnColor     = ColorParse(m_LineColor);

	} // END OF INIT



    // This is the Main Animation Loop Code. It gets executed every sleep
    // cycle If something needs to be done.
    public void DoGrafixUpdate()
    {
        int index = 0;
        ItemOvered = -1;
        String tString,tStringLast;
        Color Current_LColor;
        Polygon tTriang;
        TxtXOffset = 0;

        // Color the Screen
        DBGrafix.setColor(m_BackgColor);
        DBGrafix.fillRect(0,0,size().width,size().height);

        // Draw the Text and stuff JW--Spacing Messed up...--JW
        DBGrafix.setFont(TFfont);
        while (index < m_NumItems)
        {
            tString     = (String)m_Text.elementAt(index);
            if (index > 0)
                tStringLast = (String)m_Text.elementAt(index-1);
            else
                tStringLast = "";

            // Calculate the Texts X Position
            TxtXOffset += m_Spacing + (ff.stringWidth(tStringLast));
            // Set the color to the right value for its position
            if ((TxtXOffset < CMouse_X) &&
                (TxtXOffset+ff.stringWidth(tString) > CMouse_X))
            {
                DBGrafix.setColor(m_HlteTColor);
                ItemOvered = index;
            }
            else
                DBGrafix.setColor(m_ForeTColor);
            DBGrafix.drawString(tString,
                                TxtXOffset,
                                size().height/2+ff.getAscent()/2);
            // Draw an Arrow if there is one..
            if (m_UseArrow.equalsIgnoreCase("YES"))
            {
                tTriang = new Polygon();

                if (m_Location.equalsIgnoreCase("BOTTOM"))
                {
                    tTriang.addPoint(TxtXOffset,size().height/2-(m_LineDist+2));
                    tTriang.addPoint(TxtXOffset+6,size().height/2-(m_LineDist+2));
                    tTriang.addPoint(TxtXOffset+3,size().height/2-(m_LineDist+6));
                    tTriang.addPoint(TxtXOffset,size().height/2-(m_LineDist+2));
                    DBGrafix.fillPolygon(tTriang);
                }
                else
                {
                    tTriang.addPoint(TxtXOffset,size().height/2+m_LineDist+3);
                    tTriang.addPoint(TxtXOffset+3,size().height/2+m_LineDist+6);
                    tTriang.addPoint(TxtXOffset+6,size().height/2+m_LineDist+3);
                    tTriang.addPoint(TxtXOffset,size().height/2+m_LineDist+3);
                    DBGrafix.fillPolygon(tTriang);
                }
            }

            index++;
        }
        // Make the New Fade Color for the lines Zero or Negative Fade speed
        // Ignores Fade altogether
        if (m_FadeSpeed > 0)
        {
            Current_LColor = MakeColor(m_ClnColor,m_BackgColor,FadePercent);
            FadeUpdate();
        }
        else
            Current_LColor = m_ClnColor;
        DBGrafix.setColor(Current_LColor);
        DBGrafix.drawLine(CMouse_X-m_BarWidth,
                          size().height/2-m_LineDist,
                          CMouse_X+m_BarWidth,
                          size().height/2-m_LineDist);
        DBGrafix.drawLine(CMouse_X-m_BarWidth,
                          size().height/2+m_LineDist,
                          CMouse_X+m_BarWidth,
                          size().height/2+m_LineDist);
        // Now Draw the Message if there is one... (DUM DUM DUUHHHMMMMM)
        if (ItemOvered >= 0)
        {
            DBGrafix.setColor(m_MsgTColor);
            DBGrafix.setFont(TMfont);
            if (m_Location.equalsIgnoreCase("bottom"))
                DBGrafix.drawString((String)m_Message.elementAt(ItemOvered),
                                CMouse_X-25,
                                size().height/2+m_LineDist+3+fm.getAscent());
            else // top Default Case
                DBGrafix.drawString((String)m_Message.elementAt(ItemOvered),
                                CMouse_X-25,
                                size().height/2-m_LineDist-3);
        }
    }


    // A simple routine that increments or decrements the current
    // fade level based upon a predefined speed (FadeStep);
    public void FadeUpdate()
    {
        float FadeStep;
        FadeStep = (float)0.005*m_FadeSpeed;
        switch (FadeDirection)
        {
            case 0: // Up
                FadePercent = FadePercent + FadeStep;
                if (FadePercent >= 1)
                {
                    FadePercent = 1;
                    FadeDirection = 1;
                }
            break;
            case 1: // Down
                FadePercent = FadePercent - FadeStep;
                if (FadePercent <= 0)
                {
                    FadePercent = 0;
                    FadeDirection = 0;
                }
            break;
        }
    } // End of Fade Update


	// Marquee Paint Handler Calls Animation Routine
	// every update.. which happens every sleep cycle
	//***********************************************
	public void paint(Graphics g)
	{
	    DoGrafixUpdate();
		g.drawImage(DBImage,0,0,this);
	}

    // Override invokes paint so double buffer works.
    // **********************************************
	public void update (Graphics g)
	{
		paint(g);
	}

    // This routine merely takes a string in the form
    // "RRGGBB" where RR is hex Byte (i.e. "A8")
    // and returns the associted Integer Parts into
    // Color Variables
    // ************************************************
	public Color ColorParse(String ColorStr)
	{
	    int Red_Part,Green_Part,Blue_Part;
	    String Temp		= ColorStr.substring(0,2);
		Red_Part		= Integer.parseInt(Temp,16);
		Temp			= ColorStr.substring(2,4);
		Green_Part		= Integer.parseInt(Temp,16);
		Temp			= ColorStr.substring(4);
		Blue_Part		= Integer.parseInt(Temp,16);
		Color newColor  = new Color(Red_Part,Green_Part,Blue_Part);
		return newColor;
	}

	// This Routine Makes a Color that is <PercentComp> % of Color A
	// and the Remainder Color b. In other words, Color A is Dominant for
	// Percents higher than 0.50 It will be used in fade routine
	// ***************************************************************
	public Color MakeColor(Color a, Color b, float percentComp)
	{
	    int ared=0,agreen=0,ablue=0;
	    int bred=0,bgreen=0,bblue=0;
	    float cred=0,cgreen=0,cblue=0;
	    Color cColor;
	    ared           = a.getRed();
	    agreen         = a.getGreen();
	    ablue          = a.getBlue();
	    bred           = b.getRed();
	    bgreen         = b.getGreen();
	    bblue          = b.getBlue();
	    cred           = ((ared*percentComp)+(bred*(1-percentComp)))/(float)255;
	    cgreen         = ((agreen*percentComp)+(bgreen*(1-percentComp)))/(float)255;
	    cblue          = ((ablue*percentComp)+(bblue*(1-percentComp)))/(float)255;
	    cColor = new Color(cred,cgreen,cblue);
	    return cColor;
	}

    // This is called when you enter the page.
    // ****************************************
    public void start()
	{
		if (m_jwMenu == null)
		{
			m_jwMenu = new Thread(this);
			m_jwMenu.start();
		}
	}

    // STOP! This is called when you leave the page.
    // *********************************************
	public void stop()
	{
		if (m_jwMenu != null)
		{
			m_jwMenu.stop();
			m_jwMenu = null;
		}
	}


	// Mouse Event Handler
	// ***********************************************
	 public boolean handleEvent(Event e)
    {
        URL tempURL = null;
        if (ItemOvered >= 0)
        {
            try
            {
                tempURL = new URL ((String)m_URL.elementAt(ItemOvered));
            }
            catch (MalformedURLException ex)
            { System.out.println("CRAP"); System.exit(0);}
        }
        switch (e.id)
        {
            case Event.MOUSE_DOWN:
                //m_CurrFTColor = ColorParse(m_AColor);
                if (ItemOvered >=0)
                {
                    this.getAppletContext().showDocument(tempURL,(String)m_Target.elementAt(ItemOvered));
                    System.out.println((String)m_URL.elementAt(ItemOvered));
                }
            break;
            case Event.MOUSE_UP:
            break;
            case Event.MOUSE_ENTER:
                CMouse_X = e.x;     // Set the Current Mouse Location
                CMouse_Y = e.y;
            break;
            case Event.MOUSE_EXIT:
                CMouse_X = -(m_BarWidth+5);
                CMouse_Y = -80;
            break;
            case Event.MOUSE_MOVE:
                CMouse_X = e.x;     // Set the Current Mouse Location
                CMouse_Y = e.y;
                // Put Over Code here
            default:
        }
        return false;
    } // End of Mouse Event Handler...


	// THREAD SUPPORT
	// **************************************************
	public void run()
	{
		while (true)
		{
            // calculate the sleep time based on the frames
            // per second. sleep time is in units of
            // milliseconds.
            int nSleepValue = 1000 / m_fps;
			try
			{
				repaint();
                Thread.sleep(nSleepValue);
			}
			catch (InterruptedException e)
			{
				stop();
			}
		}
	}

    // Destroy Routine.. Destructor Code.
    // *********************************************************************
	public void destroy()
	{
	}

	// jwMenu Class Constructor
    // **************************
	public jwMenu()
	{
	}

	// jwMenu Class Destructor
    // ************************
	public void finalize()
	{
	}


} // END OF CLASS jwMenu
// ***********************************************************************

